      SUBROUTINE F600
C     ***** SCALING AND CENTERING FUNCTIONS *****
      DIMENSION MAX(3),SCAL(4),X(3),XMAX(3),XMIN(3),Z(2)
      DIMENSION A(9),AA(3,3),AAREV(3,3),AAWRK(3,3),AID(3,3),AIN(140)
      DIMENSION ATOMS(4,500),BB(3,3),CD(8,10),   CONT(5),D(3,130)
      DIMENSION DA(3,3),DP(2,130),EV(3,100),FS(3,3,48),KD(5,10),ORGN(3)
      DIMENSION P(3,100),PA(3,3,100),PAC(3,5),PAT(3,3),Q(3,3),REFV(3,3)
      DIMENSION RES(4),RMS(5),SYMB(3,3),       TS(3,48)
      DIMENSION VT(3,4),V1(4),V2(3),V3(3),V4(3),V5(3),V6(3),WRKV(3,3)
      DIMENSION XLNG(3),XO(3),XT(3)
      COMMON NG,A,AA,AAREV,AAWRK,AID,AIN,ATOMS,BB,BRDR,CD,   CONT,D
      COMMON DA,DP,DISP,EDGE,EV,FORE,FS,IN,ITILT,KD,LATM,LTNO,NATOM,NCD
      COMMON NJ,NJ2,NOUT,NSR,NSYM,ORGN,P,PA,PAC,PAT,Q,REFV,RES,RMS,SCAL1
      COMMON SCAL2,SCL,SYMB,TAPER,THETA,       TS,VIEW,VT,V1,V2
      COMMON V3,V4,V5,V6,WRKV,XLNG,XO,XT
      COMMON SHIFTX,SHIFTY
      CHARACTER*6 CHEM(100), TITLE(18)*4, TITLE2(18)*4
      COMMON /LABEL/ CHEM, TITLE, TITLE2
C     ***** DEL = 1. FOR INCRUMENTING FUNCTIONS *****
C     ***** DEL = 0. FOR REGULAR FUNCTIONS *****
      DEL=FLOAT(MOD(NJ2/10,2))
      NJ2=MOD(NJ2,10)
C     ***** EXPLICIT ORIGIN AND SCALE *****
      IF(AIN(1))602,604,602
  602 XO(1)=AIN(1)+XO(1)*DEL
  604 IF(AIN(2))606,608,606
  606 XO(2)=AIN(2)+XO(2)*DEL
  608 IF(AIN(3))612,612,609
  609 IF(DEL)611,611,610
  610 SCAL1=SCAL1*AIN(3)
      GO TO 612
  611 SCAL1=AIN(3)
  612 IF(AIN(4))616,616,614
C     ***** SET ELLIPSOID SCALE FACTOR *****
  614 SCAL2=AIN(4)
C     ***** AUTOMATIC ORIGIN AND/OR SCALE *****
  616 IF(NJ2-2)790,622,620
  620 XO(1)=XLNG(1)*.5
      XO(2)=XLNG(2)*.5
  622 IF(NJ2-3)625,640,625
  625 SCAL1=1.
  630 IF(LATM-1)635,635,640
  635 NG=12
      CALL ERPNT(0.,602)
      stop
  640 DO 650 J=1,3
      XMAX(J)=-1.E5
  650 XMIN(J)=1.E5
C     ***** FIT BOX AROUND SET OF ATOMS *****
      DO 670 I=1,LATM
      CALL XYZ(ATOMS(1,I),ATOMS(2,I),3)
      IF(NG)652,653,652
  652 CALL ERPNT(ATOMS(1,I),600)
      GO TO 670
  653 DO 668 J=1,3
      T1=ATOMS(J+1,I)
      IF(XMAX(J)-T1)655,660,660
  655 XMAX(J)=T1
      MAX(J)=I
  660 IF(T1-XMIN(J))665,668,668
  665 XMIN(J)=T1
  668 CONTINUE
  670 CONTINUE
C     ***** KM=TOP ATOM *****
      KM=MAX(3)
      SMULT=1.
      DO 780 M=1,5
      IF(M-2)740,675,678
C     ***** CHECK VIEW DISTANCE *****
  675 IF(VIEW)785,785,680
  678 IF(NJ2-3)680,785,680
  680 T1=ATOMS(4,KM)*SMULT
      IF(VIEW*.5-T1)685,690,690
C     ***** INCREASE VIEW DISTANCE *****
  685 VIEW=2.*T1
C     ***** FIND PERSPECTIVE PROJECTION LIMITS *****
  690 DO 700 J=1,2
      XMAX(J)=-1.E5
  700 XMIN(J)=1.E5
      DO 725 I=1,LATM
      DO 705 J=1,3
  705 X(J)=ATOMS(J+1,I)*SMULT
      T2=VIEW/(VIEW-X(3))
      DO 725 J=1,2
      T1=X(J)*T2
      IF(XMAX(J)-T1)710,715,715
  710 XMAX(J)=T1
  715 IF(T1-XMIN(J))720,725,725
  720 XMIN(J)=T1
  725 CONTINUE
C     ***** REFINE PARAMETERS *****
  740 IF(NJ2 -3)745,742,755
  742 SMUL2=1.
      GO TO 765
C     ***** AUTOMATIC SCALE ONLY *****
  745 DO 750 J=1,2
      T2=XO(J)
      SCAL(J)=(BRDR-T2)/XMIN(J)
  750 SCAL(J+2)=(XLNG(J)-BRDR-T2)/XMAX(J)
      SMUL2=AMIN1(SCAL(1),SCAL(2),SCAL(3),SCAL(4))
      GO TO 780
C     ***** AUTOMATIC SCALE AND POSITION *****
  755 DO 760 J=1,2
  760 SCAL(J)=(XLNG(J)-BRDR*2.)/(XMAX(J)-XMIN(J))
      SMUL2=AMIN1(SCAL(1),SCAL(2))
C     ***** AUTOMATIC POSITION *****
  765 DO 770 J=1,2
  770 XO(J)=.5*(XLNG(J)-SMUL2*(XMAX(J)+XMIN(J)))
  780 SMULT=SMULT*SMUL2
      VIEW=VIEW*SMUL2
  785 SCAL1=SCAL1*SMULT
  790 SCL=SCAL1*SCAL2
C     ** ELIMINATE ALL PREVIOUSLY STORED OVERLAP INFORMATION *****
      CALL LAP500(0)
      RETURN
      END
